package com.sy.coinage.util;

import com.sy.coinage.core.util.DateUtils;

import java.util.Date;
import java.util.UUID;

/**
 * 生成rfid唯一标识
 */
public class RfidEpcTool {

    public static String[] chars = new String[] { "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z", "0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z" };

    /**
     *  8位短uuid算法
     *  利用62个可打印字符，通过随机生成32位UUID，
     *  由于UUID都为十六进制，所以将UUID分成8组，
     *  每4个为一组，然后通过模62操作，
     *  结果作为索引取出字符
     * @return
     */
    public static String generateShortUuid() {
        StringBuffer shortBuffer = new StringBuffer();
        String uuid = UUID.randomUUID().toString().replace("-", "");
        for (int i = 0; i < 8; i++) {
            String str = uuid.substring(i * 4, i * 4 + 4);
            int x = Integer.parseInt(str, 16);
            shortBuffer.append(chars[x % 0x3E]);
        }
        return shortBuffer.toString();

    }

    /**
     *  年（2位）部门（1位）分割符号-（一位）短8位uuid
     * @param dept  :  部门 1，2，3，4
     * @return  String : 12位的 epc code
     */
    public static String buildEpcCode(String dept){

        StringBuffer sb = new StringBuffer();
        String year = DateUtils.toString((new Date()),"YY");
        String shortUuid = generateShortUuid();
        sb.append(year).append(dept).append("-").append(shortUuid);
        return sb.toString();
    }

    public static void main(String args[]){

       String epc = buildEpcCode("2");
       System.out.println(epc);
    }


}
